/* h8load : Download Motolora S format file to serial-line
 for h8mon by CSE Tomakomai NCT
 This program was designed and coded by SHIBUYA K.
 2005/02/26
 
 Modified by novi, 2009.
 */

#include <fcntl.h>
#include <termios.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#ifndef SERIALDEVICE
#define SERIALDEVICE "/dev/ttyS0"
#endif

#define BAUD B38400

#define CMD_LD "l"
#define CMD_LD_LEN 1
#define CMD_GO "g"
#define CMD_GO_LEN 1

#define CMD_WAIT 100000
#define SEND_WAIT 180

const char* cmd_go = "g 200100\r";

size_t getfilesize(FILE* fp)
{
	fseek(fp,0,SEEK_END);
	size_t size=ftell(fp)+1;
	rewind(fp);
	return size-1;
}

int main(int argc, char **argv)
{
	int fd;
	FILE* fin;
	struct termios att;
	char buf[2];
	
	if((fd = open(SERIALDEVICE,O_WRONLY)) == 0){
		fprintf(stderr,"Can't open %s\n",SERIALDEVICE);
		exit(1);
	}
	
	if((fin = fopen(argv[1],"rb")) == 0){
		fprintf(stderr,"Can't open %s\n",argv[1]);
		exit(1);
	}
	
	tcgetattr(fd,&att);
	cfsetispeed(&att, BAUD);
	cfsetospeed(&att, BAUD);
	att.c_lflag &= ~( ECHO | ICANON | IEXTEN | ISIG );
	att.c_iflag &= ~( BRKINT | ICRNL | INPCK | ISTRIP | IXON );
	att.c_cflag &= ~( PARENB | CSTOPB );
	att.c_cflag |= CS8;
	att.c_oflag &= ~( OPOST );
	att.c_cc[VTIME] = 0;
	att.c_cc[VMIN] = 1;
	att.c_cflag |= HUPCL | CLOCAL ;
	
	if(tcsetattr(fd, TCSANOW, &att) == -1){
		fprintf(stderr,"Error tcsetattr\n");
		exit(1);
	}
	
	// Send LOAD command to monitor
	usleep(CMD_WAIT);
	write(fd, "\rl", 2);
	usleep(CMD_WAIT);
	write(fd, "\r", 1);
	usleep(CMD_WAIT);
	
	/*
	 char bu1[1000];
	 while(1) {
	 break;
	 fgets(bu1,1000,stdin);
	 bu1[strlen(bu1)-1]=0;
	 if(strncmp(bu1,"send",4)==0) break;
	 
	 printf("read: %s\n", bu1);
	 
	 bu1[strlen(bu1)]='\r';
	 int i;
	 for (i = 0; i<strlen(bu1);i++) {
	 printf("%02x ", bu1[i]);
	 }
	 write(fd,bu1,strlen(bu1));
	 }*/
 	
	int filesize = getfilesize(fin);
	int curpos = 1;
	
	// Send MOT program
	
	while(fread(buf,1,1,fin)){
		//fputc(buf[0],stdout);
		printf("\r%d/%d (%d%%)", curpos, filesize, 100*curpos/filesize);
		curpos++;
		
		if(write(fd,buf,1) != 1){
			fprintf(stderr,"Error on write\n");
			exit(1);
		}
		usleep(SEND_WAIT);
	}
	close(fin);
	
	printf("\n");
	
	
	// Send GO command to monitor
	usleep(CMD_WAIT);
	write(fd, cmd_go, strlen(cmd_go));
	
	
	
	close(fd);
	
	return 0;
}